Multivariate Pattern Analysis in Python

### Navigation

- index
- modules |
- modules |
- PyMVPA Home |
- Sitemap »

# mvpa2.kernels.base.CustomKernel

class `mvpa2.kernels.base.``CustomKernel`(kernelfunc=None, *args, **kwargs)

  Custom Kernel defined by an arbitrary function

  Examples

  Basic linear kernel >>> k = CustomKernel(kernelfunc=lambda a,b: numpy.dot(a,b.T))

  Methods

  `add_conversion`(typename, methodfull, methodraw) | Adds methods to the Kernel class for new conversions :Parameters: typename : string Describes kernel type methodfull : function Method which converts to the new kernel object class methodraw : function Method which returns a raw kernel ..
  `as_ls`(kernel) |
  `as_np`() | Converts this kernel to a Numpy-based representation
  `as_raw_ls`(kernel) |
  `as_raw_np`() | Directly return this kernel as a numpy array.
  `cleanup`() | Wipe out internal representation
  `compute`(ds1[, ds2]) | Generic computation of any kernel Assumptions: - ds1, ds2 are either datasets or arrays, - presumably 2D (not checked neither enforced here - _compute takes ndarrays.
  `computed`(*args, **kwargs) | Compute kernel and return self
  `reset`() |

  Initialize CustomKernel with an arbitrary function.

  Parameters:

  kernelfunc : function

  > Any callable function which takes two numpy arrays and calculates a kernel function, treating the rows as samples and the columns as features. It is called from compute(d1, d2) -> func(d1,d2) and should return a numpy matrix K(i,j) which holds the kernel evaluated from d1 sample i and d2 sample j

  enable_ca : None or list of str

  > Names of the conditional attributes which should be enabled in addition to the default ones

  disable_ca : None or list of str

  > Names of the conditional attributes which should be disabled

  Methods

  `add_conversion`(typename, methodfull, methodraw) | Adds methods to the Kernel class for new conversions :Parameters: typename : string Describes kernel type methodfull : function Method which converts to the new kernel object class methodraw : function Method which returns a raw kernel ..
  `as_ls`(kernel) |
  `as_np`() | Converts this kernel to a Numpy-based representation
  `as_raw_ls`(kernel) |
  `as_raw_np`() | Directly return this kernel as a numpy array.
  `cleanup`() | Wipe out internal representation
  `compute`(ds1[, ds2]) | Generic computation of any kernel Assumptions: - ds1, ds2 are either datasets or arrays, - presumably 2D (not checked neither enforced here - _compute takes ndarrays.
  `computed`(*args, **kwargs) | Compute kernel and return self
  `reset`() |

### Navigation

- index
- modules |
- modules |
- PyMVPA Home |
- Sitemap »